class Admin::PagePartsController < ApplicationController

  layout "site_editor"
  
  before_filter :authenticate_user!
  before_filter :is_admin?
  before_filter :set_current_item
  
  def show
    @part = PagePart.find(params[:id])
    respond_to do |format|
      format.html { 
        render 'admin/items/index' 
      }
      format.js  {}
    end
  end

  def new
   
  end

  def edit
    @part = PagePart.find(params[:id])
    @module_apps = ModuleApp.excludes(widgets: nil).where(enable_frontend: true).order_by(:title, :asc)
    @module_app = @part.module_app ? @part.module_app : @module_apps[0]
    @r_tag = @part.public_r_tag.blank? ? LIST[:public_r_tags][0] : @part.public_r_tag
    @tag_objects = @r_tag.classify.constantize.all rescue nil
	
	@widget_path = @part.widget_path ? @part.widget_path : @module_app.widgets.keys[0]
	
	if @module_app.widgets.any?{|b| b.class == Array}
      @widget_style =  @module_app.widgets[@widget_path] if !@widget_path.blank? && !@module_app.widgets.blank?
	end
	
      case @module_app.key
        when 'announcement'
          @categories =  BulletinCategory.all
          @tags = AnnouncementTag.all
        when 'news'
          @categories =  NewsBulletinCategory.all
          @tags = NewsTag.all
        when 'web_resource'
          @categories =  WebLinkCategory.all
          @tags = WebResourceTag.all
        when 'archive'
          @categories =  ArchiveFileCategory.all
          @tags = ArchiveTag.all
      end
  end

  def create

  end

  def update
    @part = PagePart.find(params[:id])
	
	params[:page_part][:widget_field] = params[:page_part][:widget_field].zip( params[:page_part][:widget_field_type] ) if params[:page_part][:widget_field]	  
	params[:page_part][:widget_field_type] = nil
	  
    if @part.update_attributes(params[:page_part])
      set_children_sub_menu(@part) if @part.public_r_tag && @part.public_r_tag.eql?('sub_menu')
      flash.now[:notice] = t('update.success.content')

      if @part.page.name == 'home'
        expire_page '/'
      else
        expire_page page_path(@part.page.name)
      end
      respond_to do |format|
        format.html { 
          redirect_to admin_page_url( @part.page )
        }
        format.js  {
          @item = @part.page
        }
      end
    else
      render :action => "edit"
    end
  end

  def destroy
    @item = Page.find(params[:id])
    @item.destroy
    redirect_to admin_items_url( :parent_id => @item.parent_id )
  end
  
  def reload_widgets
    @categories =[]
    @module_app = ModuleApp.find(params[:id])
	
    @widget_path = @module_app.widgets.keys[0] if ( @module_app.widgets[0].blank? )
	
    @widget_style =  @module_app.widgets[@widget_path] if ( !@widget_path.blank? )

    case @module_app.key
      when 'announcement'
        @categories =  BulletinCategory.all
        @tags = AnnouncementTag.all
      when 'news'
        @categories =  NewsBulletinCategory.all
        @tags = NewsTag.all
      when 'web_resource'
        @categories =  WebLinkCategory.all
        @tags = WebResourceTag.all
      when 'archive'
        @categories =  ArchiveFileCategory.all
        @tags = ArchiveTag.all
    end

    respond_to do |format|
      format.js  {}
    end
  end
  
  def reload_widget_styles
    @module_app = ModuleApp.find(params[:module_app_id])
	
    @widget_style =  @module_app.widgets[params[:id]]
    
    respond_to do |format|
      format.js  {}
    end
  end

  def reload_r_tag_options
    @r_tag = (ModuleApp.find(params[:id]) rescue nil) || params[:id]
    @tag_objects = @r_tag.classify.constantize.all rescue nil
    respond_to do |format|
      format.js  {}
    end
  end

  protected

  def set_children_sub_menu(part)
    part.page.children.each do |child|
      child_part = child.page_parts.detect{ |x| x.name.eql?(part.name) } rescue nil
      child_part.update_attributes(:kind => part.kind, :public_r_tag => part.public_r_tag, :public_r_tag_object_id => part.public_r_tag_object_id) rescue nil
    end
  end
  
end
